
function [t, BottomTop3, LeftRight3, CornerPoints3] = GetNewBasis(p,n,kappa)
addpath ../SharedFunctions/
% Full basis
t = linspace(0,1,n+1-p);
o = ones(1,p);
z = zeros(1,p);
t = [z t o];
x = linspace(0,1,n);
c = [x; 0.5*sin(2*pi*x)]';

% Linear basis
tau1 = [0 0 1 1];
p_l	 = 1; 
elevation = p-p_l;

% bottom and top boundaries: 
x = linspace(0,1,n);
c1 = DomainCurves('b',x,kappa)';%[x; 0.5*sin(2*pi*x)]';
c2 = DomainCurves('t',x,kappa)';%[x; o]';
j = 1;
BottomTop1 = [];
for i = 1:n
	BottomTop1(j,:)		= c1(i,:);
	BottomTop1(j+1,:)	= c2(i,:);
	j = j+2;
end
clear c1 c2

% left and right boundaries:
x = linspace(0,1,n);
c1 = DomainCurves('l',x,kappa)';
c2 = DomainCurves('r',x,kappa)';
j = 1;
LeftRight1 = [];
for i = 1:n
	LeftRight1(j,:)		= c1(i,:);
	LeftRight1(j+1,:)	= c2(i,:);
	j = j+2;
end
clear c1 c2

% Corner points:
x = linspace(0,1,2);
c1 = DomainCurves('l',x,kappa)';
c2 = DomainCurves('r',x,kappa)';
CornerPoints1 = [c1; c2];
clear c1 c2

%Order Elevation botton-top and left-righ:
[tau2, BottomTop2] = OrderElevation(tau1, p_l, BottomTop1, elevation,n);
[tau2, LeftRight2] = OrderElevation(tau1, p_l, LeftRight1, elevation,n);

%Knot insertion botton-top and left-righ:
[tau3, BottomTop3] = KnotInsertion(t,tau2,p, BottomTop2,n);
[tau3, LeftRight3] = KnotInsertion(t,tau2,p, LeftRight2,n);


BT3 = [];
m = [1:n];
k = [1:n:n^2-n+1];
for i = 1:n
	BT3(m,:) = BottomTop3(k,:);
	m = m+n;
	k = k+1;
end

BottomTop3 = BT3;


%Order elevation and knot insertion corner points:
[tau2, CP2] = OrderElevationXiEta(tau1, p_l, CornerPoints1, elevation);
[tau3, CP3] = KnotInsertionXiEta(t,tau2,p,CP2,n);
 cpts3 = [];
 counter = 1;
for i = 1:n
	cpts3(counter,:) = CP3(i,:);
	cpts3(counter+1,:) = CP3(i+n,:);
	counter = counter + 2;
end
[tau2, CornerPoints2] = OrderElevation(tau1,p_l,cpts3,elevation,n);	
[tau3, CornerPoints3] = KnotInsertion(t,tau2,p,CornerPoints2,n);

%%{
N = PlotBasis(t,p,100);
N1 = PlotBasis(tau1,p_l,100);
N2 = PlotBasis(tau2,p,100);
N3 = PlotBasis(tau3,p,100);

%{
figure; hold on;
j = [1:n];
for i = 1:n
	plot(BottomTop3(j,1),BottomTop3(j,2),'*-');
	j = j + n;
end
title('kontrollpunkt etter knot insertion')
axis equal

figure; hold on;
j = [1:length(LeftRight3)/n];
for i = 1:n
	plot(LeftRight3(j,1),LeftRight3(j,2),'*-');
	j = j + length(LeftRight3)/n;
end
title('kontrollpunkt etter knot insertion')
axis equal

figure; hold on;
j = [1:length(CornerPoints3)/n];
for i = 1:n
	plot(CornerPoints3(j,1),CornerPoints3(j,2),'*-');
	j = j + length(CornerPoints3)/n;
end
title('kontrollpunkt etter knot insertion')
axis equal

%}




end