geometry = 'sine';
kappa = 0.5;
p = 2;
n = 22;


[KnotVec, BottomTop, LeftRight, CornerPoints] = GetNewBasis(p,n,kappa);

F = BottomTop + LeftRight - CornerPoints; 
UU = F;

KnotVecX = KnotVec; 
KnotVecY = KnotVec;
q = p;
NoDofs = length(UU); 

Sx = reshape(F(:,1),[n,n])';
Sy = reshape(F(:,2),[n,n])';

GetGeometry
GenerateMesh

[N, dN] = PlotBasis(KnotVec, p, nviz);

ux = N*Sx*N';
uy = N*Sy*N';

if strcmp('sine',geometry)
	h = [0 1 -0.5 1];
elseif strcmp('clover',geometry)
	h = [-0.5 1.5 -0.5 1.5];
elseif strcmp('jigsaw',geometry)
	h = [-3 13 0 10];
end %if

figure;
hold on
plot(ux, uy, 'Color',[0 0.447 0.741]);
plot(ux', uy', 'Color',[0 0.447 0.741]);
plot(ux(:,1),uy(:,1), 'Color',[0.85 0.325 0.098])
plot(ux(:,end),uy(:,end), 'Color',[0.85 0.325 0.098])
plot(ux(1,:),uy(1,:), 'Color',[0.85 0.325 0.098])
plot(ux(end,:),uy(end,:), 'Color',[0.85 0.325 0.098])
set(gcf,'Color','White')
xlabel('x')
ylabel('y')
title('Mesh')
axis equal
axis(h);

JacobianTest

if JacobianMinimum < 0
	disp('Negativ Jacobian!')
	MM = [0 0 0];
	RMS = [0 0 0];
else
	Metrics
end %if

