function [N_orig, N_new] = evaluateGreville(KnotVecOrig,KnotVecNew,p,q)%,startPt, endPt)
	
	startPt = 0; endPt = 1; 
	one = ones(1, q+1);
	zer = zeros(1,q+1);
	tau = [zer one];
	c = linspace(startPt, endPt, q+1);
	m = length(KnotVecNew) - (q+1);

	pts = [];
	for i = 1:m
		mu = FindMu(tau, KnotVecNew(i));
		cp = c(mu-q:mu);
		if q == 0
			pts(i) = cp(mu);
		else
			pts(i) = getB(KnotVecNew(i+1:i+q), mu, tau, q) * cp';
		end
	end
	
	for i = 1:m
        mu = FindMu(KnotVecNew,pts(i));
		temp1 = GetBasisAndDerivatives1D(KnotVecNew,q,pts(i));
		N_new(i, mu-q:mu) = temp1;
		
		mu = FindMu(KnotVecOrig,pts(i));
		temp2 = GetBasisAndDerivatives1D(KnotVecOrig,p,pts(i));
		N_orig(i, mu-p:mu) = temp2;
	end


end