% Solves least squares problem on boundary
	NoP = NoGaussPts;%length(KnotVecX)*(p + 1)*15;
	
	NobottomNodes	= length(bottomNodes);
	NoleftNodes		= length(leftNodes);
	NorightNodes	= length(rightNodes);
	NotopNodes		= length(topNodes);

	% Used for local element indexing
	bottomElement	= zeros(NoElemX, p+1);
	leftElement		= zeros(NoElemY, q+1);
	rightElement	= zeros(NoElemY, q+1);
	topElement		= zeros(NoElemX, p+1);

	% Used to keep track on the active basis functions and
	% control points on each element boundary
	bottomEdgeMesh	= zeros(NoElemX, p+1);
	leftEdgeMesh	= zeros(NoElemY, q+1);
	rightEdgeMesh	= zeros(NoElemY, q+1);
	topEdgeMesh		= zeros(NoElemX, p+1);
	
	for i = 1:NoElemX
		bottomEdgeMesh(i,:) = bottomNodes(i:i+p);
		topEdgeMesh(i,:)	= topNodes(i:i+p);
		
		bottomElement(i,:)	= (i:i+p);
		topElement(i,:)		= (i:i+p);
	end	%i
	
	
	for i = 1:NoElemY
		leftEdgeMesh(i,:)	= leftNodes(i:i+q);
		rightEdgeMesh(i,:)	= rightNodes(i:i+q);
		
		leftElement(i,:)	= (i:i+q);
		rightElement(i,:)	= (i:i+q);
	end %i

	Bx = zeros(NoCtrlPts,1);
	By = zeros(NoCtrlPts,1);
	C  = zeros(NoCtrlPts, NoCtrlPts);
	
	bottomC	= zeros(NobottomNodes, NobottomNodes);
	leftC	= zeros(NoleftNodes, NoleftNodes);
	rightC	= zeros(NorightNodes, NorightNodes);
	topC	= zeros(NotopNodes, NotopNodes);

	bottomBx= zeros(NobottomNodes,1);
	leftBx	= zeros(NoleftNodes,1);
	rightBx	= zeros(NorightNodes,1);
	topBx	= zeros(NotopNodes,1);
	
	bottomBy= zeros(NobottomNodes,1);
	leftBy	= zeros(NoleftNodes,1);
	rightBy	= zeros(NorightNodes,1);
	topBy	= zeros(NotopNodes,1);

%%% BOTTOM EDGE %%%
	for e = 1:NoElemX
		sctr	= bottomEdgeMesh(e,:);
		sctrC	= bottomElement(e,:);
		Xi_e	= ElemRangeX(e,:);
		xiC		= linspace(Xi_e(1), Xi_e(2)-eps, NoP);
			
		N = GetBasisBoundary(KnotVecX,p,xiC);
			
		bottomC(sctrC, sctrC) = bottomC(sctrC, sctrC) + N'*N;

		x = N*controlPts(sctr,1); y = N*controlPts(sctr,2);
		ff = BottomBoundary(x,y);
		bottomBx(sctrC) = bottomBx(sctrC) + N'*ff(:,1);
		bottomBy(sctrC) = bottomBy(sctrC) + N'*ff(:,2);

	end %e

C(bottomNodes,bottomNodes) =  C(bottomNodes,bottomNodes) + bottomC;
Bx(bottomNodes) = Bx(bottomNodes) +  bottomBx;
By(bottomNodes) = By(bottomNodes) +  bottomBy;

%%% LEFT EDGE %%%
	for e = 1:NoElemY
		sctr	= leftEdgeMesh(e,:);
		sctrC	= leftElement(e,:);
		Eta_e	= ElemRangeY(e,:);
		etaC	= linspace(Eta_e(1), Eta_e(2)-eps, NoP);
			
		M = GetBasisBoundary(KnotVecY, q, etaC);
			
		leftC(sctrC, sctrC) = leftC(sctrC, sctrC) + M'*M;

		x = M*controlPts(sctr,1); y = M*controlPts(sctr,2);
		ff = LeftBoundary(x,y);
		leftBx(sctrC) = leftBx(sctrC) + M'*ff(:,1);
		leftBy(sctrC) = leftBy(sctrC) + M'*ff(:,2);

	end %e
	
C(leftNodes,leftNodes) =  C(leftNodes,leftNodes) + leftC;
Bx(leftNodes) = Bx(leftNodes) +  leftBx;
By(leftNodes) = By(leftNodes) +  leftBy;

%%% RIGHT EDGE %%%
	for e = 1:NoElemY
		sctr = rightEdgeMesh(e,:);
		sctrC = rightElement(e,:);
		Eta_e = ElemRangeY(e,:);
		etaC = linspace(Eta_e(1), Eta_e(2)-eps, NoP);
		
		M = GetBasisBoundary(KnotVecY, q, etaC);
			
		rightC(sctrC, sctrC) = rightC(sctrC, sctrC) + M'*M;
 
		x = M*controlPts(sctr,1); y = M*controlPts(sctr,2);
		ff = RightBoundary(x,y);
		rightBx(sctrC) = rightBx(sctrC) + M'*ff(:,1);
		rightBy(sctrC) = rightBy(sctrC) + M'*ff(:,2);
	end %e

C(rightNodes,rightNodes) =  C(rightNodes,rightNodes) + rightC;
Bx(rightNodes) = Bx(rightNodes) +  rightBx;
By(rightNodes) = By(rightNodes) +  rightBy;

%%% TOP EDGE %%%
	for e = 1:NoElemX
		sctr = topEdgeMesh(e,:);
		sctrC = topElement(e,:);
		Xi_e = ElemRangeX(e,:);
		xiC = linspace(Xi_e(1), Xi_e(2)-eps, NoP);
		
		N = GetBasisBoundary(KnotVecX,p,xiC);
			
		topC(sctrC, sctrC) = topC(sctrC, sctrC) + N'*N;
			
		x = N*controlPts(sctr,1); y = N*controlPts(sctr,2);
		ff = TopBoundary(x,y);
		topBx(sctrC) = topBx(sctrC) + N'*ff(:,1);
		topBy(sctrC) = topBy(sctrC) + N'*ff(:,2);
	end %e
	
C(topNodes,topNodes) =  C(topNodes,topNodes) + topC;
Bx(topNodes) = Bx(topNodes) +  topBx;
By(topNodes) = By(topNodes) +  topBy;


Fix = [bottomNodes leftNodes rightNodes topNodes];
FixedNodes = unique(Fix);
	for i = length(Bx):-1:1;
		if not(ismember(i,FixedNodes))
			C(i,:) = [];
			C(:,i) = [];
			Bx(i)  = [];
			By(i)  = [];
		end %if
	end %if
	
Fixedx = (C\Bx);
Fixedy = (C\By);
	
FixedNodesX = FixedNodes;
FixedNodesY = FixedNodes + NoCtrlPts; 
 
f = f - A(:,FixedNodesX)*Fixedx;  % modify the  force vector
f = f - A(:,FixedNodesY)*Fixedy;
f(FixedNodesX) = Fixedx';
f(FixedNodesY) = Fixedy';
A(FixedNodesX,:) = 0;  % zero out the rows and  columns of the K matrix
A(FixedNodesY,:) = 0;
A(:,FixedNodesX) = 0;
A(:,FixedNodesY) = 0;

for i = 1:length(FixedNodesX)
	A(FixedNodesX(i), FixedNodesX(i)) = 1;
	A(FixedNodesX(i)+NoCtrlPts, FixedNodesX(i)+NoCtrlPts) = 1;
end