%%% Problem spesifications
if strcmp(geometry, 'clover')
	Youngs = 1200;
	poissons = 0.2;
	vv = poissons;
    BottomBoundary	= @(x,y) [x, -kappa*sin(pi*x)];
    TopBoundary		= @(x,y) [x, 1+kappa*sin(pi*x)];
    LeftBoundary	= @(x,y) [-kappa*sin(pi*y), y];
    RightBoundary	= @(x,y) [1+kappa*sin(pi*y), y];

elseif strcmp(geometry,'sine')
	Youngs = 0.1;
	poissons = 0.499;
	vv = poissons;
    BottomBoundary	= @(x,y) [x, kappa*sin(2*pi*x)];
    TopBoundary		= @(x,y) [x, 1 + (y-y)];
    LeftBoundary	= @(x,y) [(x-x), y];
    RightBoundary	= @(x,y) [1+(x-x), y];

elseif strcmp(geometry, 'jigsaw')
    Youngs = 1200;
    poissons = 0.2;
    vv = poissons;
    knt1 = [0 0 0 1 2 3 4 5 6 7 8 8 8]/8;
    knt2 = knt1;
    p1x = [0 3 4 3   4 6 7   6 7 10];
    p1y = [0 0 1 1.5 3 3 1.5 1 0 0];
    p2x = p1x;
    p2y = 10-p1y;
    q1x=-p1y; q1y=p1x;
    q2x = 10-q1x;
    q2y = q1y;

    sp{1}=spmak(knt1,[p1x;p1y]);
    sp{2}=spmak(knt1,[p2x;p2y]);
    sp{3}=spmak(knt2,[q1x;q1y]);
    sp{4}=spmak(knt2,[q2x;q2y]);

    BottomBoundary	= @(tt,y) fnval(sp{1}, tt)';
    TopBoundary		= @(tt,y) fnval(sp{2}, tt)';
    LeftBoundary	= @(x,tt) fnval(sp{3}, tt)';
    RightBoundary	= @(x,tt) fnval(sp{4}, tt)';

end

startX = 0; endX = 1;
startY = 0; endY = 1;

func = @(x,y) [0 0];

% Spline initialization
n = 20;
p = 2;
KnotVecX = linspace(0,1,n+1);
zer = zeros(1,p); one = ones(1,p);
KnotVecX = [zer KnotVecX one];

KnotVecY = KnotVecX;
q = p; 

NoPtsX      = length(KnotVecX) - (p+1);
NoPtsY      = length(KnotVecY) - (q+1);
NoGaussPts	= max(p,q) + 1;
NoCtrlPts	= NoPtsX * NoPtsY; 
NoDofs		= NoCtrlPts * 2; 

GetControlPts

NoPx = p + 1;
NoPy = q + 1;

uniqueX     = unique(KnotVecX);
uniqueY     = unique(KnotVecY);
NoElemX     = length(uniqueX) - 1;
NoElemY     = length(uniqueY) - 1;

% Visualization specification
nviz = NoPx*NoElemX; 
mviz = NoPy*NoElemY;