addpath ../SharedFunctions/
geometry = 'clover';
kappa = 0.5;

boundaryInitialization

BottomBoundary	= @(x,y) [x, (y-y)];
TopBoundary		= @(x,y) [x, 1+(y-y)];
LeftBoundary	= @(x,y) [(x-x), y];
RightBoundary	= @(x,y) [1+(x-x), y];
Main;

r = 0;
iterations = 15;

for i = 1:iterations
	controlPts = [Ux'; Uy']';
	BottomBoundary	= @(x,y) [x, -r*sin(pi*x)];
	TopBoundary		= @(x,y) [x, 1+r*sin(pi*x)];
	LeftBoundary	= @(x,y) [-r*sin(pi*y), y];
	RightBoundary	= @(x,y) [1+r*sin(pi*y), y];
	Main
    r = r + kappa/iterations;
end

QuasiPlot

Metrics