function [ElemRange, ElemConn] = Connectivity(p, KnotVec, NoElem)
    % The function finds the range and connectivities 
    % for each element in 1D
    
    ElemRange   = zeros(NoElem, 2);
    ElemConn    = zeros(NoElem, p+1);
    ElemKnotInd = zeros(NoElem, 2);
    
    element     = 1;
    previous    = KnotVec(1);
    
    for i = 1:length(KnotVec)
       current = KnotVec(i);
       if KnotVec(i) ~= previous
           ElemRange(element,:)     = [previous, current];
           ElemKnotInd(element,:)   = [i-1, i];
           element = element + 1;
       end %if
       previous = current;
    end %i
    
    NoRepeated = 0;
    
    for i = 1:NoElem
        ind         = ( ElemKnotInd(i,1) - p + 1 ):ElemKnotInd(i,1);
        previous    = KnotVec(ind);
        current     = ones(1,p) * KnotVec(ElemKnotInd(i,1));

        if isequal(previous, current) && (length(nonzeros(previous)) > 1);
            NoRepeated =  NoRepeated + 1;
        end %if

        ElemConn(i,:) = (ElemKnotInd(i,1) - p ):ElemKnotInd(i,1);
    end %i

end