% Unique knots in xi and eta direction
uniqueX     = unique(KnotVecX);
uniqueY     = unique(KnotVecY);

% Number of elements in xi and eta direction, and in total
NoElemX     = length(uniqueX) - 1;
NoElemY     = length(uniqueY) - 1;
NoElem      = NoElemX * NoElemY;

% Element connectivities and range
ElemConn    = zeros(NoElem, (p+1)*(q+1) );
ElemRange   = zeros(NoElem, 4);

chan        = zeros(NoPtsY, NoPtsX);
counter     = 1;

for i = 1:NoPtsY
    for j = 1:NoPtsX
        chan(i,j) = counter;
        counter = counter + 1;
    end %j
end %i

[ElemRangeX, ElemConnX] = Connectivity(p, KnotVecX, NoElemX);
[ElemRangeY, ElemConnY] = Connectivity(q, KnotVecY, NoElemY);

e = 1;
for y = 1:NoElemY
    yConn = ElemConnY(y,:);
    for x = 1:NoElemX
        c = 1;
        xConn = ElemConnX(x,:);
        for i = 1:length(yConn)
            for j = 1:length(xConn)
                ElemConn(e,c) = chan(yConn(i), xConn(j));
                c = c + 1; 
            end %j
        end %i
        e = e + 1;
    end %x
end %y

e = 1;
for i = 1:size(ElemRangeY,1)
    for j = 1:size(ElemRangeX,1)
        ElemRange(e,1:2)      = ElemRangeX(j,:);
        ElemRange(e,3:4)      = ElemRangeY(i,:);
        e                     = e + 1;
    end %j
end %i
