function [basis, dNdxi, dNdeta] = GetBasisAndDerivatives(xi, eta, p, q, KnotVecX, KnotVecY)
    % The function returns the basis and first derivatives
    % with respect to the points xi and eta.


    if abs(xi - KnotVecX(end)) < eps
        xi = KnotVecX(end) - eps;
    end
    if abs(eta - KnotVecY(end)) < eps
        eta = KnotVecY(end) - eps; 
    end
    
    % Get Basis: 
    [N, dN] = GetBasisAndDerivatives1D(KnotVecX, p, xi);
    [M, dM] = GetBasisAndDerivatives1D(KnotVecY, q, eta);
    
    k = 1;
    for j = 1:(q+1)
        for i = 1:(p+1)
            basis(k) = N(i)*M(j);
            dNdxi(k) = dN(i)*M(j);
            dNdeta(k) = dM(j)*N(i);
            k = k + 1;
        end %i
	end %j

end
