function [N, dN] = GetBasisAndDerivatives1D(KnotVec, p, x)
    
    mu = FindMu(KnotVec, x);
    
    % Basis:
    N = 1;
    for k = 1:p
        R = 0;
        for i = 1:k
            R(i,i)   = (KnotVec(mu+i) - x) / (KnotVec(mu+i) - KnotVec(mu+i-k));
            R(i,i+1) = (x - KnotVec(mu+i-k)) / (KnotVec(mu+i) - KnotVec(mu+i-k));
        end %i
        N = N * R;
    end %k
    
    % Derivative:
    dN = 1;
    for k = 1:(p-1)
        R = 0;
        for i = 1:k
            R(i,i) = (KnotVec(mu+i) - x) / (KnotVec(mu+i) - KnotVec(mu+i-k));
            R(i,i+1) = (x - KnotVec(mu+i-k)) / (KnotVec(mu+i) - KnotVec(mu+i-k));
        end %i
        dN = dN*R;
    end %k
    %
    for k = (p-1+1):p
        dR = 0;
        for i = 1:k
            dR(i,i) = (-1) / (KnotVec(mu+i) - KnotVec(mu+i-k));
            dR(i,i+1) = (1) / (KnotVec(mu+i) - KnotVec(mu+i-k));
        end %i
        dN = dN*dR;
    end %k
    dN = (factorial(p)/factorial(p-1))^(1)*dN;
    
end