function [sizeMetric, shapeMetric, skewMetric] = GetMetrics(x,y, NoElem, NoElemX, geometry,kappa)

	totalArea	= zeros(NoElem,1);
	shapeMetric = zeros(NoElem,1);
	skewMetric	= zeros(NoElem,1);
	index		= zeros(NoElem,4);
	
	index(1,1:2) = [1 2];
	index(1,3:4) = [NoElemX+2 NoElemX+3];
	
	teller = 1; 
	for i = 2:NoElem
		if mod(teller,NoElemX) == 0
			index(i,:) = index(i-1,:) + 2;
		else
			index(i,:) = index(i-1,:) + 1;
		end %if
		teller = teller + 1; 
	end	 %i
	
	for i = 1:NoElem
		ind1 = index(i,1);
		ind2 = index(i,2);
		ind3 = index(i,3);
		ind4 = index(i,4);
		
		A1 = [x(ind2)-x(ind1) x(ind3)-x(ind1);
			  y(ind2)-y(ind1) y(ind3)-y(ind1);];
		AA1 = A1'*A1; 
		  
		A2 = [x(ind4)-x(ind2) x(ind1)-x(ind2);
			  y(ind4)-y(ind2) y(ind1)-y(ind2)];
		AA2 = A2'*A2;  

		A3 = [x(ind3)-x(ind4) x(ind2)-x(ind4);
			  y(ind3)-y(ind4) y(ind2)-y(ind4);];
		AA3 = A3'*A3;
		
		A4 = [x(ind1)-x(ind3) x(ind4)-x(ind3);
			  y(ind1)-y(ind3) y(ind4)-y(ind3)];
		AA4 = A4'*A4;
		  
		totalArea(i) = (det(A1) + det(A3))/2;
		
		if totalArea(i) < 0 || norm((det(A1) + det(A3))-(det(A2) + det(A4))) > 2*eps%det(A1) < 0 || det(A2) < 0 || det(A3) < 0 || det(A4) < 0
			totalArea(i) = 0;
		end %if
		
		shapeMetric(i) = 8/((AA1(1,1) + AA1(2,2))/det(A1) + ...
						 (AA2(1,1) + AA2(2,2))/det(A2) + ...
						 (AA3(1,1) + AA3(2,2))/det(A3) + ...
						 (AA4(1,1) + AA4(2,2))/det(A4));
					 
		if shapeMetric(i) < 0 || shapeMetric(i) > 1
			shapeMetric(i) = 0;
		end %if
					 
		skewMetric(i) = 4 / (sqrt(AA1(1,1)*AA1(2,2))/det(A1) + ...
			sqrt(AA2(1,1)*AA2(2,2))/det(A2) + sqrt(AA3(1,1)*AA3(2,2))/det(A3)...
			+ sqrt(AA4(1,1)*AA4(2,2))/det(A4));
		
		if skewMetric(i) < 0 || skewMetric(i) > 1
			skewMetric(i);
			skewMetric(i) = 0;
		end %if

		
	end %i

	NoElemY = NoElem / NoElemX; 
	
	if strcmp(geometry, 'jigsaw')
		referenceSize = (100/NoElem);
	elseif strcmp(geometry, 'sine')
		referenceSize = (1/NoElemX)*(1/NoElemY);
	elseif strcmp(geometry, 'clover')
		referenceSize = (1 + ((8*kappa)/pi))/NoElem;
	end %if
	
	tau = totalArea./referenceSize;
	sizeMetric = min(tau, 1./tau); 
end
