UU = [Ux Uy];

Jacobian	 = zeros(NoElemY*NoPy, NoElemX*NoPx);

xx = 1;
yy = 1; 

for e = 1:NoElem

	% Element interval (xi_i, xi_(i+1))
    Xi_e    = ElemRange(e,1:2);                                             
    Eta_e   = ElemRange(e,3:4);
	
	xi	= linspace(Xi_e(1), Xi_e(2)-eps, NoPx);
	eta = linspace(Eta_e(1), Eta_e(2)-eps, NoPy);

    Conn    = ElemConn(e,:); 
	D		= zeros(NoPy, NoPx);
	
	for i = 1:NoPx
		Xi = xi(i);
		for j = 1:NoPy
			Eta = eta(j);
			
			[N, dNdxi, dNdeta] = GetBasisAndDerivatives(Xi, Eta, p, q, ...
														KnotVecX, KnotVecY);
			
			jacob	= UU(Conn,:)'*[dNdxi' dNdeta'];
			detJ	= det(jacob);	
			
			D(j,i) = detJ; 				
	
		end %j
	end %i
	
	if mod(e, NoElemY) == 1 && e~=1
		yy = yy + NoPy;
	end %if
	
	Jacobian(yy:yy+NoPy-1,xx:xx+NoPx-1) = D;
	xx = NoPx*mod(e,NoElemX) + 1;
end %e

figure;
surf(ux,uy,Jacobian,'EdgeColor', 'None', 'facecolor', 'interp');
colorbar;
view(2);
hold on
plot(ux(:,1),uy(:,1), 'r',ux(:,end),uy(:,end), 'r',ux(1,:),uy(1,:), 'r',ux(end,:),uy(end,:), 'r')
grid off
title('Jacobian')

