x = reshape(ux', [1, nviz^2] );
y = reshape(uy',[1, nviz^2]);

NoElemX = length(ux)-1;
NoElem = NoElemX^2;

addpath ../SharedFunctions/

[sizeMetric,shapeMetric,skewMetric]=GetMetrics(x,y,NoElem,NoElemX,geometry,kappa);

	SizeShape	= sizeMetric.*shapeMetric;
	SizeSkew	= sizeMetric.*skewMetric;

	% Root-Mean-Square:
	sizeRMS			= sqrt( (1/NoElem) *( sizeMetric'	*sizeMetric ) );
	shapeRMS		= sqrt( (1/NoElem) *( shapeMetric'	*shapeMetric) );
	skewRMS			= sqrt( (1/NoElem) *( skewMetric'	*skewMetric ) );
	SizeShapeRMS	= sqrt( (1/NoElem) *( SizeShape'	*SizeShape	) );
	SizeSkewRMS		= sqrt( (1/NoElem) *( SizeSkew'		*SizeSkew	) );
	
	% MaxMin: 
	sizeMM		= min(sizeMetric)	/max(sizeMetric);
	shapeMM		= min(shapeMetric)	/max(shapeMetric);
	skewMM		= min(skewMetric)	/max(skewMetric);
	SizeShapeMM	= min(SizeShape)	/max(SizeShape);
	SizeSkewMM	= min(SizeSkew)		/max(SizeSkew);
	
RMS = [sizeRMS	shapeRMS	skewRMS SizeShapeRMS	SizeSkewRMS];
MM	= [sizeMM	shapeMM		skewMM	SizeShapeMM		SizeSkewMM]; 