geometry = 'sine'
%geometry = 'clover';
%geometry = 'jigsaw';
kappa = 0.5;
startX = 0; endX = 1; startY = startX; endY = endX;
addpath ../SharedFunctions/

if strcmp(geometry,'sine')
    alpha = @(x,y) ((y^(7/4))*(1-0.25*x));
elseif strcmp(geometry,'clover')
    alpha = @(x,y) ((y-y.^2)*(x-x.^2));
else
    alpha = @(x,y) 1;
end %if


if strcmp(geometry, 'clover')
    BottomBoundary	= @(x,y) x;
    TopBoundary		= @(x,y) x;
    LeftBoundary	= @(x,y) -kappa*sin(pi*y);
    RightBoundary	= @(x,y) 1 + kappa*sin(pi*y);
elseif strcmp(geometry, 'sine')
    BottomBoundary	= @(x,y) x;
    TopBoundary		= @(x,y) x;
    LeftBoundary	= @(x,y) (y-y);
    RightBoundary	= @(x,y) 1+(y-y);
elseif strcmp(geometry, 'jigsaw')
	knt1 = [0 0 0 1 2 3 4 5 6 7 8 8 8]/8;
	knt2 = knt1; 
	p1x = [0 1 2 3 4 6 7 8 9 10];
	p1y = [0 0 0 0 0 0 0 0 0 0];
	p2x = p1x;
	p2y = 10-p1y;

	q1x=-p1y; q1y=p1x;
	q2x = 10-q1x;
	q2y = q1y;

	sp{1}=spmak(knt1,[p1x;p1y]);
	sp{2}=spmak(knt1,[p2x;p2y]);
	sp{3}=spmak(knt2,[q1x;q1y]);
	sp{4}=spmak(knt2,[q2x;q2y]);

    FirstArgument = @(x) x(1,:)';
    BottomBoundary	= @(x,y) FirstArgument(fnval(sp{1}, x));
    TopBoundary		= @(x,y) FirstArgument(fnval(sp{2}, x));
    LeftBoundary	= @(x,y) FirstArgument(fnval(sp{3}, y));
    RightBoundary	= @(x,y) FirstArgument(fnval(sp{4}, y));
end %if

% Solve first Poisson problem
Main
xx = u;  
Ux = U; 



if strcmp(geometry,'clover')
    BottomBoundary	= @(x,y) -kappa*sin(pi*x);
    TopBoundary		= @(x,y) 1 + kappa*sin(pi*x);
    LeftBoundary	= @(x,y) y;
    RightBoundary	= @(x,y) y;

elseif strcmp(geometry,'sine')
    BottomBoundary	= @(x,y) kappa*sin(2*pi*x);
    TopBoundary		= @(x,y) 1 +(x-x);
    LeftBoundary	= @(x,y) y;
    RightBoundary	= @(x,y) y;

elseif strcmp(geometry,'jigsaw')
    SecondArgument = @(x) x(2,:)';
    BottomBoundary	= @(x,y) SecondArgument(fnval(sp{1}, x));
    TopBoundary		= @(x,y) SecondArgument(fnval(sp{2}, x));
    LeftBoundary	= @(x,y) SecondArgument(fnval(sp{3}, y));
    RightBoundary	= @(x,y) SecondArgument(fnval(sp{4}, y));
end %if

% Solve second Poisson problem
Main
yy = u; 
Uy = U;


figure
hold on
plot(xx,yy, 'Color', [0, 0.447, 0.741]);
plot(xx',yy', 'Color', [0, 0.447, 0.741]);
axis equal
xlabel('x'); ylabel('y');

JacobianTest

if min(min(Jacobian)) < 0
	MM = [0 0 0];
	RMS = [0 0 0];
else
	Metrics
end